
/////////////////////////////////////////////////////////////////////
// DESP-C++ (Discrete-Event Simulation Package)
// Version 1.1, February 1998
// Jerome Darmont
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// eventc.h: Event Manager classes definition
// Variable with simulated systems
/////////////////////////////////////////////////////////////////////

// Active resources declaration
// E.g. Class AR;

/////////////////////////////////////////////////////////////////////
// CLASS EventManager
/////////////////////////////////////////////////////////////////////
// Simulation events management
/////////////////////////////////////////////////////////////////////

// The Event Manager must "know" all (active and passive) resources.

class EventManager {

  public:

    // Methods

    EventManager(Simulation *sim);      // Constructor
    ~EventManager();                    // Destructor
    void ExecuteEvent(int code, Client *client); // Event execution
    void Init();                        // Initialization
    void InitRep();                     // Replication initialization 
    void Stats();                       // Stats computation (end of replication)
    void DisplayStats();                // Statistics display

  private:

    // Attributes

    Simulation *simul;                  // Pointer toward simulation object

    // Passive resources
    // E.g. Resource *pr;

    // Active resources
    // E.g. AR *ar;

};

/////////////////////////////////////////////////////////////////////
// CLASS Client
/////////////////////////////////////////////////////////////////////
// Custom simulation entity
/////////////////////////////////////////////////////////////////////

class Client {

  public:
           // Add here (in public) additional attributes

           Client *next;
           Client *previous;

};

/////////////////////////////////////////////////////////////////////
// CLASS AR
/////////////////////////////////////////////////////////////////////
// Sample active resource
/////////////////////////////////////////////////////////////////////

// Active resources must "know" all the passive resources they use
// and the "next" active resources (pointers)

//class AR: public Resource {

//  public:

//    Constructor

//    AR(char n[STRS], int cap, Simulation *sim);

//    Events

//    void Event0(Client *client);
//    void Event1(Client *client);

//};

