
/////////////////////////////////////////////////////////////////////
// DESP-C++ (Discrete-Event Simulation Package)
// Version 1.1, February 1998
// Jerome Darmont
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// eventc.h: Event Manager methods definition
// Variable with simulated systems
/////////////////////////////////////////////////////////////////////

#include "stdlib.h"
#include "string.h"

/////////////////////////////////////////////////////////////////////
// CLASS EventManager
/////////////////////////////////////////////////////////////////////

// CLASS EventManager: Constructor

EventManager::EventManager(Simulation *sim) {

  simul=sim;

  // Passive resources instantiation
  // E.g. pr=new Resource("PR",2,simul);

  // Active resources instantiation
  // E.g. ar=new AR("AR",1,simul);
}

// CLASS EventManager: Destructor

EventManager::~EventManager() {

  // Passive resources destruction
  // E.g. delete pr;

  // Active resources destruction
  // E.g. delete ar;
}

// CLASS EventManager: Events execution

void EventManager::ExecuteEvent(int code, Client *client) {

  switch(code) {

  //case 0:  ar->Event0(client);break; // Initial event - MANDATORY!!

  // Sample events

  //case 10: ar->Event10(client);break;
  //case 11: ar->Event11(client);break;

  default: printf("Error: unknown event #%d at time %f\n",code,simul->Tnow());
  }
}

// CLASS EventManager: Stats init for each resource

void EventManager::Init() {

  // Passive resources
  //pr->ResetStats();
  // Active resources
  //ar->ResetStats();
}

// CLASS EventManager: Replications initialization

void EventManager::InitRep() {

  // Scheduler
  simul->Sched()->Purge();
  // Passive resources
  //pr->ResetCounters();
  //pr->PurgeQueue();
  // Active resources
  //ar->ResetCounters();
  //ar->PurgeQueue();
}

// CLASS EventManager: Stats computation for each resource

void EventManager::Stats() {

  // Passive resources
  //pr->Stats();
  // Active resources
  //ar->Stats();
}

// CLASS EventManager: Stats display for each resource

void EventManager::DisplayStats() {

  printf("\n*** SIMULATION STATISTICS ***\n\n");
  printf("\n*** PASSIVE RESOURCES\n");
//  pr->DisplayStats();
  printf("\n*** ACTIVE RESOURCES\n");
//  ar->DisplayStats();
}

/////////////////////////////////////////////////////////////////////
// CLASS AR (sample active resource)
/////////////////////////////////////////////////////////////////////

// CLASS AR: Constructor

// AR::AR(char n[STRS], int cap, Simulation *sim): Resource(n, cap, sim) {
// }

// CLASS AR : Event #0

// void AR::Event0(Client *client) {
//   Code for event #0
// }

// ...